%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%        Proyecto final de carrera         %%%
%%%   - Francisco Cruz Fernandez             %%%
%%%   - Uppsala universitet                  %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%I0 the selected image to perform the segmentation.


%La idea aqu es, conocidos los niveles de threshold para los puntos medios
%en los 9 cuadrantes, interpolaremos para conocer los puntos intermedios a
%estos. Para los bordes ser otra historia.

tic;

%Resaltarlos un poco antes (Restulado = res)

%Llamamos a resaltar9par para calcular los puntos.

resaltar9part;

A=level0;
B=level1;
C=level2;
D=level3;
E=level4;
F=level5;
G=level6;
H=level7;
I=level8;

a = [384 512];
b = [384 1536];
c = [384 2560];
d = [1152 512];
e = [1152 1536];
f = [1152 2560];
g = [1920 512];
h = [1920 1536];
i2 = [1920 2560];

inter = zeros(2304,3072);


n1=e(2)-d(2);
n2=a(1)-d(1);
n12=n1*n2;

n3=f(2)-e(2);
n4=b(1)-e(1);
n34=n3*n4;

%Points betwen A B;D E

for i=384:1152
    for j=512:1536
        
        %x2 = e(2);   x1 = d(2); y2 = a(1);  y1 = d(1);  x=j; y=i;
        
        part1=(D/n12)*((e(2)-j)*(a(1)-i));
        part2=(E/n12)*((j-d(2))*(a(1)-i));
        part3=(A/n12)*((e(2)-j)*(i-d(1)));
        part4=(B/n12)*((j-d(2))*(i-d(1)));
        
        sum=part1+part2+part3+part4;
        
        inter(i,j)=sum;
        
    end
end

%Points betwen B C;E F

for i=384:1152
    for j=1536:2560
        
        %x2 = e(2);   x1 = d(2); y2 = a(1);  y1 = d(1);  x=j; y=i;
        
        part1=(E/n34)*((f(2)-j)*(b(1)-i));
        part2=(F/n34)*((j-e(2))*(b(1)-i));
        part3=(B/n34)*((f(2)-j)*(i-e(1)));
        part4=(C/n34)*((j-e(2))*(i-e(1)));
        
        sum=part1+part2+part3+part4;
        
        inter(i,j)=sum;
        
    end
end


n5=h(2)-g(2);
n6=d(1)-g(1);
n56=n5*n6;

n7=i2(2)-h(2);
n8=e(1)-h(1);
n78=n7*n8;

%Points betwen D E;G H

for i=1152:1920
    for j=512:1536
        
        %x2 = e(2);   x1 = d(2); y2 = a(1);  y1 = d(1);  x=j; y=i;
        
        part1=(G/n56)*((h(2)-j)*(d(1)-i));
        part2=(H/n56)*((j-g(2))*(d(1)-i));
        part3=(D/n56)*((h(2)-j)*(i-g(1)));
        part4=(E/n56)*((j-g(2))*(i-g(1)));
        
        sum=part1+part2+part3+part4;
        
        inter(i,j)=sum;
        
    end
end


%Points betwen E F;H I

for i=1152:1920
    for j=1536:2560
        
        %x2 = e(2);   x1 = d(2); y2 = a(1);  y1 = d(1);  x=j; y=i;
        
        part1=(H/n78)*((i2(2)-j)*(e(1)-i));
        part2=(I/n78)*((j-h(2)) *(e(1)-i));
        part3=(E/n78)*((i2(2)-j)*(i-h(1)));
        part4=(F/n78)*((j-h(2)) *(i-h(1)));
        
        sum=part1+part2+part3+part4;
        
        inter(i,j)=sum;
        
    end
end




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%Since here, I have the center square calculated, lets calculate now the
%borders

p=zeros(16,1);

p(1)=A;
p(2)=(A+B)/2;
p(3)=(B+C)/2;
p(4)=C;
p(5)=(A+D)/2;
p(6)=(A+B+D+E)/4;
p(7)=(B+C+E+F)/4;
p(8)=(C+F)/2;
p(9)=(D+G)/2;
p(10)=(D+E+G+H)/4;
p(11)=(E+F+H+I)/4;
p(12)=(F+I)/2;
p(13)=G;
p(14)=(G+H)/2;
p(15)=(H+I)/2;
p(16)=I;

p1 = [1 1];
p2 = [1 1024];
p3 = [1 2048];
p4 = [1 3072];
p5 = [768 1];
p6 = [768 1024];
p7 = [768 2048];
p8 = [768 3072];
p9 = [1536 1];
p10 = [1536 1024];
p11 = [1536 2048];
p12 = [1536 3072];
p13 = [2304 1];
p14 = [2304 1024];
p15 = [2304 2048];
p16 = [2304 3072];




%Points betwen p1 p2
%              p5 p6 

for i=1:383
    for j=1:1024
                
        part1=p(5)/((p6(2)-p5(2))*(p1(1)-p5(1)))*((p6(2)-j)*(p1(1)-i));
        part2=p(6)/((p6(2)-p5(2))*(p1(1)-p5(1)))*((j-p5(2))*(p1(1)-i));
        part3=p(1)/((p6(2)-p5(2))*(p1(1)-p5(1)))*((p6(2)-j)*(i-p5(1)));
        part4=p(2)/((p6(2)-p5(2))*(p1(1)-p5(1)))*((j-p5(2))*(i-p5(1)));
        
        sum=part1+part2+part3+part4;
        
        inter(i,j)=sum;
        
    end
end

for i=384:768
    for j=1:511
                
        part1=p(5)/((p6(2)-p5(2))*(p1(1)-p5(1)))*((p6(2)-j)*(p1(1)-i));
        part2=p(6)/((p6(2)-p5(2))*(p1(1)-p5(1)))*((j-p5(2))*(p1(1)-i));
        part3=p(1)/((p6(2)-p5(2))*(p1(1)-p5(1)))*((p6(2)-j)*(i-p5(1)));
        part4=p(2)/((p6(2)-p5(2))*(p1(1)-p5(1)))*((j-p5(2))*(i-p5(1)));
        
        sum=part1+part2+part3+part4;
        
        inter(i,j)=sum;
        
    end
end



%Points betwen p5 p6
%              p9 p10 

for i=769:1536
    for j=1:511
               
        part1=p(9)/((p10(2)-p9(2))*(p5(1)-p9(1)))*((p10(2)-j)*(p5(1)-i));
        part2=p(10)/((p10(2)-p9(2))*(p5(1)-p9(1)))*((j-p9(2))*(p5(1)-i));
        part3=p(5)/((p10(2)-p9(2))*(p5(1)-p9(1)))*((p10(2)-j)*(i-p9(1)));
        part4=p(6)/((p10(2)-p9(2))*(p5(1)-p9(1)))*((j-p9(2))*(i-p9(1)));
        
        sum=part1+part2+part3+part4;
        
        inter(i,j)=sum;
        
    end
end



%Points betwen p9 p10
%              p13 p14

for i=1537:1920
    for j=1:511
                
        part1=p(13)/((p14(2)-p13(2))*(p9(1)-p13(1)))*((p14(2)-j)*(p9(1)-i));
        part2=p(14)/((p14(2)-p13(2))*(p9(1)-p13(1)))*((j-p13(2))*(p9(1)-i));
        part3=p(9)/((p14(2)-p13(2))*(p9(1)-p13(1)))*((p14(2)-j)*(i-p13(1)));
        part4=p(10)/((p14(2)-p13(2))*(p9(1)-p13(1)))*((j-p13(2))*(i-p13(1)));
        
        sum=part1+part2+part3+part4;
        
        inter(i,j)=sum;
        
    end
end

for i=1921:2304
    for j=1:1024
                
        part1=p(13)/((p14(2)-p13(2))*(p9(1)-p13(1)))*((p14(2)-j)*(p9(1)-i));
        part2=p(14)/((p14(2)-p13(2))*(p9(1)-p13(1)))*((j-p13(2))*(p9(1)-i));
        part3=p(9)/((p14(2)-p13(2))*(p9(1)-p13(1)))*((p14(2)-j)*(i-p13(1)));
        part4=p(10)/((p14(2)-p13(2))*(p9(1)-p13(1)))*((j-p13(2))*(i-p13(1)));
        
        sum=part1+part2+part3+part4;
        
        inter(i,j)=sum;
        
    end
end
 

%Points betwen p2 p3
%              p6 p7

for i=1:383
    for j=1025:2048
               
        part1=p(6)/((p7(2)-p6(2))*(p2(1)-p6(1)))*((p7(2)-j)*(p2(1)-i));
        part2=p(7)/((p7(2)-p6(2))*(p2(1)-p6(1)))*((j-p6(2))*(p2(1)-i));
        part3=p(2)/((p7(2)-p6(2))*(p2(1)-p6(1)))*((p7(2)-j)*(i-p6(1)));
        part4=p(3)/((p7(2)-p6(2))*(p2(1)-p6(1)))*((j-p6(2))*(i-p6(1)));
        
        sum=part1+part2+part3+part4;
        
        inter(i,j)=sum;
        
    end
end



%Points betwen p10 p11
%              p14 p15


for i=1921:2304
    for j=1025:2048
               
        part1=p(14)/((p15(2)-p14(2))*(p10(1)-p14(1)))*((p15(2)-j)*(p10(1)-i));
        part2=p(15)/((p15(2)-p14(2))*(p10(1)-p14(1)))*((j-p14(2))*(p10(1)-i));
        part3=p(10)/((p15(2)-p14(2))*(p10(1)-p14(1)))*((p15(2)-j)*(i-p14(1)));
        part4=p(11)/((p15(2)-p14(2))*(p10(1)-p14(1)))*((j-p14(2))*(i-p14(1)));
        
        sum=part1+part2+part3+part4;
        
        inter(i,j)=sum;
        
    end
end

 

%Points betwen p3 p4
%              p7 p8 

for i=1:383
    for j=2049:3072
                
        part1=p(7)/((p8(2)-p7(2))*(p3(1)-p7(1)))*((p8(2)-j)*(p3(1)-i));
        part2=p(8)/((p8(2)-p7(2))*(p3(1)-p7(1)))*((j-p7(2))*(p3(1)-i));
        part3=p(3)/((p8(2)-p7(2))*(p3(1)-p7(1)))*((p8(2)-j)*(i-p7(1)));
        part4=p(4)/((p8(2)-p7(2))*(p3(1)-p7(1)))*((j-p7(2))*(i-p7(1)));
        
        sum=part1+part2+part3+part4;
        
        inter(i,j)=sum;
        
    end
end

for i=384:768
    for j=2561:3072
                
        part1=p(7)/((p8(2)-p7(2))*(p3(1)-p7(1)))*((p8(2)-j)*(p3(1)-i));
        part2=p(8)/((p8(2)-p7(2))*(p3(1)-p7(1)))*((j-p7(2))*(p3(1)-i));
        part3=p(3)/((p8(2)-p7(2))*(p3(1)-p7(1)))*((p8(2)-j)*(i-p7(1)));
        part4=p(4)/((p8(2)-p7(2))*(p3(1)-p7(1)))*((j-p7(2))*(i-p7(1)));
        
        sum=part1+part2+part3+part4;
        
        inter(i,j)=sum;
        
    end
end


%Points betwen p7 p8
%              p11 p12 

for i=769:1536
    for j=2561:3072
               
        part1=p(11)/((p12(2)-p11(2))*(p7(1)-p11(1)))*((p12(2)-j)*(p7(1)-i));
        part2=p(12)/((p12(2)-p11(2))*(p7(1)-p11(1)))*((j-p11(2))*(p7(1)-i));
        part3=p(7)/((p12(2)-p11(2))*(p7(1)-p11(1)))*((p12(2)-j)*(i-p11(1)));
        part4=p(8)/((p12(2)-p11(2))*(p7(1)-p11(1)))*((j-p11(2))*(i-p11(1)));
        
        sum=part1+part2+part3+part4;
        
        inter(i,j)=sum;
        
    end
end


%Points betwen p9 p10
%              p13 p14

%Points betwen p11 p12
%              p15 p16

for i=1537:1920
    for j=2561:3072
                
        part1=p(15)/((p16(2)-p15(2))*(p11(1)-p15(1)))*((p16(2)-j)*(p11(1)-i));
        part2=p(16)/((p16(2)-p15(2))*(p11(1)-p15(1)))*((j-p15(2))*(p11(1)-i));
        part3=p(11)/((p16(2)-p15(2))*(p11(1)-p15(1)))*((p16(2)-j)*(i-p15(1)));
        part4=p(12)/((p16(2)-p15(2))*(p11(1)-p15(1)))*((j-p15(2))*(i-p15(1)));
        
        sum=part1+part2+part3+part4;
        
        inter(i,j)=sum;
        
    end
end

for i=1921:2304
    for j=2049:3072
                
        part1=p(15)/((p16(2)-p15(2))*(p11(1)-p15(1)))*((p16(2)-j)*(p11(1)-i));
        part2=p(16)/((p16(2)-p15(2))*(p11(1)-p15(1)))*((j-p15(2))*(p11(1)-i));
        part3=p(11)/((p16(2)-p15(2))*(p11(1)-p15(1)))*((p16(2)-j)*(i-p15(1)));
        part4=p(12)/((p16(2)-p15(2))*(p11(1)-p15(1)))*((j-p15(2))*(i-p15(1)));
        
        sum=part1+part2+part3+part4;
        
        inter(i,j)=sum;
        
    end
end

%%%END of borders

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%




%  The output binary image BW has values of 1 (white) for all
%  pixels in the input image with luminance greater than LEVEL and 0 (black)
%  for all other pixels. (Note that you specify LEVEL in the range [0,1], 
%  regardless of the class of the input image.)


inter = 255 * inter; %To become the [0 1] pixels to gray pixels

result = res > inter; %Do the thresholding

%imtool(result);

toc;
